/* 
class GoBoxes takes care of everything in the upper part of the screen.
 */

#define INBETWEEN  (windowwidth-BUTTONSIZE-15*FONTWIDTH-10)/3


class GoBoxes{
private:

  //from TopBoxes
  char CH[2];
  int last_mn, last_b, last_w, numb, numw, start_left, start_right;
  int komiI;
  int coord_x_coord;
  bool conflic;
  bool komiB;
  bool gameStart;
  bool counting, scrollDown, scrollUp;
  bool displaycomment;
  bool toggleDisplay;
  int boardsz;
  int handicp;
  int widt, xstar;
  //from MSB
  int stonerad;
  int curchoices;
  int* x;
  int* y;
  bool autosave, sound, coordinates;

  GoGraphic* graph;
  Move* lastcur;

  void drawStones(bool, int);
  void drawCheckmark(int,int);

  void drawCounting(int,int);
  int drawBlack();
  int drawWhite();
  void drawMovenumber();

  void drawTopBoxes();

  void drawChoices(Move* cur, int = COM_BEGIN);
  int isInMoveButton(int,int);
  void drawComment(Move* cur, int  = COM_BEGIN);

public:
  GoBoxes(int bs, int kom, bool, GoGraphic* graph);
  void resize(int width, bool autosave, bool sound, bool coordinates,
	      int boardsize, int xstart, int width, Move* current);
  int isInButton(int,int);
  void redraw(Move* cur);
  void draw(int,int,int,int, Move* cur, int=COM_REDRAW);
  void setHandi(int);
  void setKomi(int,bool);
  void setGameStart();
  void setCounting();
  void setConflict(bool );
  void unsetCounting();
  void setBoardProp(int,int, int);

  //from MSB
  void setProperties(int w, bool as, bool sd, bool coord);

};

void GoBoxes::resize(int width, bool autosave, bool sound, bool coordinates,
		     int boardsize, int xstart, int wi, Move* current){
  setProperties(width, autosave, sound, coordinates);
  setBoardProp(boardsize, xstart, wi);
  drawChoices(current, COM_BEGIN);
}

void GoBoxes::drawStones(bool white, int mark){
  int i;
  for(i=0; i<curchoices; i++){
    if(i!= mark){
      graph->fCircle( x[i]- stonerad, y[i]-stonerad, 2*stonerad, white);

      graph->circle( x[i] - stonerad, y[i]-stonerad, 2*stonerad);
    }
  }
  
  graph->fRectangle( x[mark]-stonerad-1, y[mark]-stonerad-1,
		 2*stonerad+3, 2*stonerad+3, BLACK);
  if(white)
    graph->fCircle( x[mark]- stonerad, y[mark]-stonerad, 2*stonerad, WHITE);
  graph->circle(x[mark] - stonerad, y[mark]-stonerad, 
		2*stonerad, WHITE);
  
}

void GoBoxes::drawCheckmark(int x, int y){
   graph->line(x+ BUTTONSIZE/2, y+ (5*BUTTONSIZE)/8, 
	       x+ (3*BUTTONSIZE)/4, y+ BUTTONSIZE);
   graph->line(x+ BUTTONSIZE/2, y+ (5*BUTTONSIZE)/8-1, 
	       x+ (3*BUTTONSIZE)/4, y+ BUTTONSIZE-1);
   graph->line(x+ (3*BUTTONSIZE)/4, y+ BUTTONSIZE, 
	       x+ BUTTONSIZE, y+ BUTTONSIZE/2);
   graph->line(x+ (3*BUTTONSIZE)/4, y+ BUTTONSIZE-1, 
	       x+ BUTTONSIZE, y+ BUTTONSIZE/2-1);
}

char* dig3i2str(int im, char* moves){
    if(im > 99){
      moves[0] = (im / 100)+'0';
      im %= 100;
      moves[1] = (im / 10)+'0';
      im %= 10;
      moves[2] = im + '0';
      moves[3] = 0;
    }
    else if(im > 9){
      moves[0] = (im / 10)+'0';
      im %= 10;
      moves[1] = im + '0';
      moves[2] = 0;
    }
    else {
      moves[0] = im + '0';
      moves[1] = 0;
    }
    return moves;
}

int digits(int mn){
  if(mn > 99) return 3;
  if(mn > 9) return 2;
  return 1;
}


void GoBoxes::drawCounting(int b, int w){
  char moves[MAXSTRING+1];
  int im;

  graph->emptyRectangle(0,0,windowwidth-BUTTONSIZE, 
			windowheight-windowwidth - FONTHEIGHT);
  graph->dString( ((windowwidth-BUTTONSIZE)/(FONTWIDTH*2)-8)*FONTWIDTH,
		  ((windowheight-windowwidth)/(FONTHEIGHT*2)-1)*FONTHEIGHT,
		  "Mark dead stones");
  
  if(b > w) {
    im = b-w;
    strcpy(moves, "Black +");
    if(komiB) im --;
    dig3i2str(im, &moves[strlen(moves)]);
    if(komiB) strcat(moves, ".5");
  }
  else if(w>b){
    im = w - b;
    strcpy(moves, "White +");
    dig3i2str(im, &moves[strlen(moves)]);
    if(komiB) strcat(moves, ".5");
  }
  else {
    strcpy(moves, "Jigo!");
  }
  graph->emptyRectangle( 0, 
	   ((windowheight-windowwidth)/(FONTHEIGHT*2))*FONTHEIGHT+1,
			 windowwidth-BUTTONSIZE, FONTHEIGHT);
  	      
  graph->dString( ((windowwidth-BUTTONSIZE)/(FONTWIDTH*2)-(strlen(moves)/2))*
		  FONTWIDTH,
		  ((windowheight-windowwidth)/(FONTHEIGHT*2)+1)*FONTHEIGHT,
		  moves);
  
}

int GoBoxes::drawBlack (){
  char moves[MAXSTRING+1];

  dig3i2str(last_b, moves);

  graph->emptyRectangle(xstar, 
			windowheight-windowwidth+1-FONTHEIGHT, 
			(numb)*FONTWIDTH, FONTHEIGHT);

  graph->dString( xstar, windowheight-windowwidth, "B:");
  
  
  graph->dString( xstar + 2*FONTWIDTH+FONTWIDTH/2, 
	      windowheight-windowwidth, 
	      moves);
  return 3+strlen(moves);
}

int GoBoxes::drawWhite (){
  char moves[MAXSTRING+1];
  dig3i2str(last_w, moves);
  if(komiB){
    int im=strlen(moves);
    moves[im]='.';
    moves[im+1]='5';
    moves[im+2]=0;
  }
  
  graph->emptyRectangle(xstar + (boardsz-1)*widt -
			numw*FONTWIDTH, 
			windowheight-windowwidth+1-FONTHEIGHT, numw*FONTWIDTH, 
			FONTHEIGHT);
  graph->dString( xstar+(boardsz-1)*widt -
	      (strlen(moves)+3)*FONTWIDTH+FONTWIDTH/2, 
	      windowheight-windowwidth, 
	      "W:");

  graph->dString( xstar+(boardsz-1)*widt -
	      strlen(moves)*FONTWIDTH, windowheight-windowwidth, 
	      moves);
  return 3+ strlen(moves);
}

void GoBoxes::drawMovenumber(){
  char moves[MAXSTRING+1];
  graph->emptyRectangle(xstar + numb*FONTWIDTH, 
		 windowheight-windowwidth+1-FONTHEIGHT, 
		 (boardsz-1)*widt-(numb+numw)*FONTWIDTH, 
		 FONTHEIGHT);
  // moveNumber
  
  dig3i2str(last_mn,moves);
  
  int sstart_left = 
    xstar+((boardsz-1)*widt - (numw+numb+strlen(moves)+7)*
	   FONTWIDTH)/2 +numb * FONTWIDTH;
  int sstart_right = sstart_left + (4 + digits(last_mn))*FONTWIDTH;
  if(!gameStart || start_left > sstart_left) start_left = sstart_left;
  if(!gameStart || start_right < sstart_right) start_right = sstart_right;
  int sstring = start_left+3*FONTWIDTH;
  graph->dString( (start_right-sstring-digits(last_mn)*FONTWIDTH)/2+sstring,
		  windowheight-windowwidth, moves);
  
  
  if(!counting && gameStart) {
    graph->dString( start_left, windowheight-windowwidth, "< <");
    graph->dString( start_right, windowheight-windowwidth, "> >");
    
    graph->dString( start_left + FONTWIDTH/3, 
		windowheight-windowwidth, "<");
    graph->dString( start_right + 2*FONTWIDTH - FONTWIDTH/3,
		windowheight-windowwidth, ">");
  }
}

void GoBoxes::drawChoices(Move* cur, int param){
  scrollDown = scrollUp = toggleDisplay = false;
   if(cur == 0 ) return;
   if((curchoices = cur->howManyNexts())<2) curchoices = 0;
   
   if(curchoices!=0 && cur->comment!=0){
     graph->rectangle(windowwidth-2*BUTTONSIZE+1,0,
		      BUTTONSIZE-1,BUTTONSIZE-1);
     graph->dString(windowwidth+1-BUTTONSIZE- (BUTTONSIZE+FONTWIDTH)/2, 
		    (BUTTONSIZE+FONTHEIGHT)/2-1,"T");
     toggleDisplay=true;
   }
   
   
   if(cur->comment != 0 && (displaycomment || curchoices == 0)){
     drawComment(cur, param);
     return;
   }
   if(curchoices ==0) return;
   displaycomment = false;

   //   graph->emptyRectangle( 0, 0, windowwidth-BUTTONSIZE, 
   //		  windowheight-windowwidth-FONTHEIGHT); 
   //   printf("%d\n", curchoices);
   delete x;
   delete y;
   x = new int[curchoices];
   y = new int[curchoices];
   
   int perRow = (windowheight-windowwidth-FONTHEIGHT-BUTTONSIZE) 
     / (2*stonerad);
                                     // "nice" choices-value
   if(curchoices <= perRow){
     int inbetween = (int)(((float)windowheight-windowwidth-FONTHEIGHT
			    -BUTTONSIZE-2*stonerad*curchoices)/(curchoices+1));
     for(int i=0; i<curchoices; i++){
       y[i] = inbetween*(i+1)+stonerad * (1+2*i)+BUTTONSIZE;
       x[i] = (windowwidth-BUTTONSIZE)/2;
     }
   }
   else {
     int rows = curchoices / (perRow + perRow -1);
     //     fprintf(stderr, "%d\n", rows);
     //     bool startMax = ((curchoices - rows * (perRow + perRow -1)) == perRow);
     int i,j;
     for(i=0; i < rows; i++)
       for(j=0; j < perRow+perRow-1; j++){
	 x[i*(perRow+perRow-1) + j] = ((windowwidth-BUTTONSIZE)/2 )
	   - (2*stonerad*rows) + (i*4*stonerad) + ((j>=perRow)?(2*stonerad) : 0);
	   
	 y[i*(perRow+perRow-1) + j] = 2*stonerad*(j%perRow) + 
	   stonerad*((j>=perRow)?2:1)+BUTTONSIZE;
       }
     for( i = rows*(2*perRow-1); i < curchoices; i++){
        x[i] = (windowwidth-BUTTONSIZE)/2 + 2*stonerad*rows 
	 + ( ((i%(2*perRow-1)) >= perRow)?(2*stonerad) : 0);
       y[i] = (( (i %(2*perRow-1)) % perRow) * 2*stonerad) + 
	 (( (i %(2*perRow-1))>=perRow)? (2*stonerad) : stonerad) + BUTTONSIZE;
     }
   }

   drawStones((cur->getFirstNext())->White, cur->nextNumber);
     
}

GoBoxes::GoBoxes(int bs, int kom, bool plusFive, GoGraphic* gr){
  graph = gr;
  lastcur = 0;
  komiI=kom;
  komiB=plusFive;
  last_mn = last_b = last_w = -1;
  numb=numw=0;
  boardsz=bs;
  handicp = 0;
  xstar=0;
  widt = windowwidth/19;
  gameStart = false;
  counting = false;
  conflic = false;
  scrollDown = scrollUp = false;
  displaycomment = DEFAULT_DISPLAY_COMMENT;
  toggleDisplay = false;
  start_right = start_left = windowwidth/2;
  CH[0] = 'M';
  CH[1] = 0;
  coord_x_coord = (windowwidth -
		   (2*BUTTONSIZE+FONTWIDTH/2+
		    strlen(AUTOSAVESTRING)*FONTWIDTH+1) 
		   - 3*BUTTONSIZE - FONTWIDTH * (strlen(SOUNDSTRING))
		   -FONTWIDTH/2 - strlen(COORDSTRING) * FONTWIDTH 
		   - BUTTONSIZE/2 - FONTWIDTH/2)/2 
    + 2*BUTTONSIZE+FONTWIDTH/2+1+strlen(AUTOSAVESTRING)*FONTWIDTH;
  curchoices = 0;
}

int GoBoxes::isInButton(int ex, int ey){
  if(ex >=windowwidth-BUTTONSIZE){      //right Buttons
    if( ey < BUTTONSIZE)
      return QUIT;
    if(ey < 2*BUTTONSIZE)       // M/L/R/V
      return MVR;
    if (ey < 45)                  // passing move
      return PASSB;
    return NOTHING;
  }

  if(!gameStart && ey < BUTTONSIZE){                  // introbuttons
     if (ex <= FONTWIDTH+1)
       return DECR_SIZE;
     if(ex >= 4*FONTWIDTH+3 && 
                ex <= 5*FONTWIDTH+4)
       return INCR_SIZE;
     if (ex >=5*FONTWIDTH+3+INBETWEEN&& // left handi
	 ex < 6*FONTWIDTH+4+INBETWEEN)
       return DECR_HANDI;
     if (ex > 8*FONTWIDTH+5+INBETWEEN && //right handi
	 ex <= 9*FONTWIDTH+7+INBETWEEN)
       return INCR_HANDI;
     if(ex > 6*FONTWIDTH+4+INBETWEEN &&           //rotate handi
	ex < 8*FONTWIDTH+5+INBETWEEN && handicp != 0)
       return ROT_HANDI;
     if(ex >= 9*FONTWIDTH+6+2*INBETWEEN &&        // left komi
	ex <= 10*FONTWIDTH+7+2*INBETWEEN)
       return DECR_KOMI;
     if(ex >= 14*FONTWIDTH+8+2*INBETWEEN &&
	ex <= 15*FONTWIDTH+9+2*INBETWEEN)
       return INCR_KOMI;
     return NOTHING;
  }


  if(ey < windowheight - windowwidth &&
     ey > windowheight - windowwidth - FONTHEIGHT){
    if(ex > start_left && ex < start_left + FONTWIDTH + FONTWIDTH/3)
      return TOGAMESTART;
    
    if(ex > start_left+2*FONTWIDTH && ex < start_left + 3*FONTWIDTH)
      return DECR_MOVE;
    
    if(ex > start_right && ex < start_right + FONTWIDTH)
      return INCR_MOVE;
    
    if(ex > start_right+2*FONTWIDTH - FONTWIDTH/3 && 
       ex < start_right + 3*FONTWIDTH)
      return TOGAMEEND;
  }

  if(!displaycomment)
    for(int i=0; i<curchoices; i++)
      if(ex>= x[i]-stonerad && ex <= x[i]+stonerad && 
	 ey >= y[i]-stonerad && ey <= y[i] + stonerad)
	return i;
  
  if(ex>=(3*BUTTONSIZE)/2 && ex < 2*BUTTONSIZE && ey<BUTTONSIZE){
    autosave = !autosave;
    //    drawomment(0);
    return TOGGLEAUTOSAVE;
  }
  else if ( ey < BUTTONSIZE && ex<windowwidth-(5*BUTTONSIZE)/2
	    && ex>= windowwidth - 3*BUTTONSIZE){
    sound = !sound;
    //    drawomment(0);
    return TOGGLESOUND;
  }
#if defined ALLOWTOGGLECOORD
  else if ( ey < BUTTONSIZE && ex<coord_x_coord + BUTTONSIZE/2
	    && ex>= coord_x_coord){
    coordinates = !coordinates;
    //    drawomment(0);
    return TOGGLECOORD;
  }
#endif
  else if(ey<BUTTONSIZE && ex<BUTTONSIZE && ey>BUTTONSIZE/2 && scrollDown){
    return SCROLLDOWN;
  }
  else if(ey<BUTTONSIZE/2 && ex<BUTTONSIZE && scrollUp)
    return SCROLLUP;
  else if(toggleDisplay && ey<BUTTONSIZE && ex<windowwidth-BUTTONSIZE 
	  && ex > windowwidth-2*BUTTONSIZE){
    displaycomment = !displaycomment;
    return TOGGLEDISPLAY;
  }
  return NOTHING;
}

void GoBoxes::drawTopBoxes(){
    // draw autosave
    graph->rectangle((3*BUTTONSIZE)/2, BUTTONSIZE/2, BUTTONSIZE/2, BUTTONSIZE/2);
    graph->dString(2*BUTTONSIZE+FONTWIDTH/2+1,BUTTONSIZE, AUTOSAVESTRING);
    
    if (autosave) drawCheckmark (BUTTONSIZE,0);
    // draw sound
    graph->rectangle(windowwidth - 3*BUTTONSIZE, BUTTONSIZE/2, 
		     BUTTONSIZE/2, BUTTONSIZE/2); 
    graph->dString(windowwidth-3*BUTTONSIZE 
		   - FONTWIDTH * (strlen(SOUNDSTRING))-FONTWIDTH/2, 
		   BUTTONSIZE, SOUNDSTRING);
    
    if (sound) drawCheckmark (windowwidth - (7*BUTTONSIZE)/2,0);
    
#if defined ALLOWTOGGLECOORD
    // draw coord-box
    graph->rectangle (coord_x_coord, BUTTONSIZE/2,
		     BUTTONSIZE/2, BUTTONSIZE/2); 

    graph->dString(coord_x_coord + BUTTONSIZE/2 + FONTWIDTH/2 +1, 
		   BUTTONSIZE, COORDSTRING);

    if (coordinates) drawCheckmark (coord_x_coord - BUTTONSIZE/2,0);
#endif
}


void GoBoxes::redraw(Move* cur){
  char moves[MAXSTRING+1];
  int im;

  if(counting) drawCounting(last_b, last_w);
  
  if(!gameStart){
    // size
    graph->rectangle(0,0,5*FONTWIDTH+3,BUTTONSIZE-1);

    graph->line(FONTWIDTH+1,0,FONTWIDTH+1, BUTTONSIZE-1);
    graph->line( 4*FONTWIDTH+2,0,4*FONTWIDTH+2, BUTTONSIZE-1);

    graph->dString( 1, (BUTTONSIZE-FONTHEIGHT)/2 + FONTHEIGHT-1, "<");
    graph->dString( 4*FONTWIDTH+4, (BUTTONSIZE-FONTHEIGHT)/2 + FONTHEIGHT-1, 
		    ">");

    if(boardsz > 9){
      moves[0] = boardsz/10 + '0';
      moves[1] = boardsz % 10 + '0';
      moves[2] = 0;
    }
    else {moves[0] = '9'; moves[1] = 0;}

    graph->dString( FONTWIDTH+2+FONTWIDTH/((strlen(moves)==1)?1:2),
		    (BUTTONSIZE-FONTHEIGHT)/2 + FONTHEIGHT-1, moves);
    
    // handicap

    graph->rectangle( 5*FONTWIDTH+3+INBETWEEN,0,
		   4*FONTWIDTH+3,BUTTONSIZE-1);
    graph->line( 6*FONTWIDTH+4+INBETWEEN,0,6*FONTWIDTH+4+INBETWEEN, BUTTONSIZE-1);
    graph->line( 8*FONTWIDTH+5+INBETWEEN,0,8*FONTWIDTH+5+INBETWEEN, BUTTONSIZE-1);
    
    graph->dString(5*FONTWIDTH+4+INBETWEEN,
		   (BUTTONSIZE-FONTHEIGHT)/2 + FONTHEIGHT-1, "<");

    graph->dString(8*FONTWIDTH+7+INBETWEEN, 
		   (BUTTONSIZE-FONTHEIGHT)/2 + FONTHEIGHT-1, ">");

    moves[0] = handicp + '0';
    moves[1] = 0;

    graph->emptyRectangle(6*FONTWIDTH+5+INBETWEEN,1,
			  2*FONTWIDTH, BUTTONSIZE-2);

    graph->dString( 6*FONTWIDTH+6+INBETWEEN+FONTWIDTH/2, 
		    (BUTTONSIZE-FONTHEIGHT)/2 + FONTHEIGHT-1, moves);
    
    // komi
    
    graph->rectangle(9*FONTWIDTH+6+2*INBETWEEN,0,
		   6*FONTWIDTH+3,BUTTONSIZE-1);
    graph->line( 10*FONTWIDTH+7+2*INBETWEEN,0,
	      10*FONTWIDTH+7+2*INBETWEEN, BUTTONSIZE-1);
    graph->line( 14*FONTWIDTH+8+2*INBETWEEN,0,
	      14*FONTWIDTH+8+2*INBETWEEN, BUTTONSIZE-1);
    
    
    graph->dString(9*FONTWIDTH+7+2*INBETWEEN,
		   (BUTTONSIZE-FONTHEIGHT)/2 + FONTHEIGHT-1, "<");

    graph->dString(14*FONTWIDTH+10+2*INBETWEEN, 
		   (BUTTONSIZE-FONTHEIGHT)/2 + FONTHEIGHT-1, ">");
    
    moves[0] = komiI + '0';
    moves[1] = '.';
    moves[2] = (komiB)?'5':'0';
    moves[3] = 0;

    graph->emptyRectangle(10*FONTWIDTH+8+2*INBETWEEN,1,
			  4*FONTWIDTH, BUTTONSIZE-2);

    graph->dString( 10*FONTWIDTH+8+2*INBETWEEN+FONTWIDTH/2, 
		    (BUTTONSIZE-FONTHEIGHT)/2 + FONTHEIGHT-1, moves);
    

  }
    

  // buttons on the right

  // horiz
  graph->line( windowwidth-BUTTONSIZE,0, windowwidth-1,0);
  graph->line( windowwidth-BUTTONSIZE,BUTTONSIZE-1, 
	       windowwidth-1,BUTTONSIZE-1);

  // vert
  if(!counting){
    graph->line( windowwidth-BUTTONSIZE,0, 
		 windowwidth-BUTTONSIZE, 3*BUTTONSIZE-1);
    graph->line( windowwidth-1,0, 
		 windowwidth-1,3*BUTTONSIZE-1);

    // horiz
    graph->line( windowwidth-BUTTONSIZE, 2*BUTTONSIZE-1,
		 windowwidth-1,2*BUTTONSIZE-1);
    graph->line( windowwidth-BUTTONSIZE,3*BUTTONSIZE-1,
		 windowwidth-1,3*BUTTONSIZE-1);
  }
  else{
    graph->line( windowwidth-BUTTONSIZE,0, 
		 windowwidth-BUTTONSIZE,
		 BUTTONSIZE-1);
    graph->line( windowwidth-1,0, 
		 windowwidth-1,BUTTONSIZE-1);   
  }

  // cross
  graph->line( windowwidth-BUTTONSIZE+2,3,
	       windowwidth-4,BUTTONSIZE-3);
  graph->line( windowwidth-BUTTONSIZE+3,3,
	       windowwidth-4,BUTTONSIZE-4);
  graph->line( windowwidth-BUTTONSIZE+3,2,
	       windowwidth-3,BUTTONSIZE-4);
  
  graph->line( windowwidth-BUTTONSIZE+2,
	       BUTTONSIZE-4,windowwidth-4,2);
  graph->line( windowwidth-BUTTONSIZE+3,
	       BUTTONSIZE-4,windowwidth-4,3);
  graph->line( windowwidth-BUTTONSIZE+3,BUTTONSIZE-3,
	       windowwidth-3,3);
  
  graph->dString( windowwidth-BUTTONSIZE+6, 
		  2*BUTTONSIZE-3, CH);

  if(!counting) graph->dString( windowwidth-BUTTONSIZE+6,
				3*BUTTONSIZE-3,"P");
  

  // black
  numb = drawBlack();

  // white
  numw = drawWhite();

  // movenumber
  drawMovenumber();
  
  if(conflic){
    graph->emptyRectangle(xstar, windowheight-windowwidth+1-FONTHEIGHT, 
			  (boardsz-1)*widt, FONTHEIGHT);
    graph->dString( (windowwidth-strlen(CONFLICTSTRING)*FONTWIDTH)/2,
		    windowheight-windowwidth,CONFLICTSTRING);
    
  }

  if(gameStart && !counting) {
//      graph->emptyRectangle(0, 0, windowwidth-BUTTONSIZE, 
//  			windowheight-windowwidth-FONTHEIGHT); 
  
    drawTopBoxes();
    drawChoices(cur, COM_REDRAW);
    lastcur=cur;
  }
}

void GoBoxes::draw(int mn, int b, int w, int what, 
		   Move* cur, int param){
  //  if(cur->comment !=0) printf("%s\n",cur->comment);
  static bool redraw = true;
  char moves[20];
  int im;
  char dowhat;
  switch(what){
  case MOVEBUTTON: 
    dowhat = 'M';
    break;
  case VARIATIONBUTTON:
    dowhat = 'V';
    break;
  case REPLACEBUTTON:
    dowhat = 'R';
    break;
  case ADDBUTTON:
    dowhat = 'A';
    break;
  case EMPTYBUTTON:
    dowhat = ' ';
    break;
  default:
    fprintf(stderr, "TopBoxes->draw: ERROR: what = %d\n", what);
  }

  if(counting) drawCounting(b,w);

  if(dowhat != CH[0]){
    CH[0] = dowhat;
    graph->emptyRectangle(windowwidth-BUTTONSIZE+6,
			  2*BUTTONSIZE-3-FONTHEIGHT,FONTWIDTH, 
			  FONTHEIGHT);
    graph->dString( windowwidth-BUTTONSIZE+6, 2*BUTTONSIZE-3, CH);

  }

  if(b!= last_b||redraw){
    last_b = b;
    numb = drawBlack();
  }
    
  if(w!=last_w || redraw){
    last_w = w;
    numw = drawWhite();
  }

  if(mn != last_mn || redraw){
    last_mn = mn;
    drawMovenumber();
  }

  redraw=false;
  if(conflic){
    graph->emptyRectangle(xstar, 
			  windowheight-windowwidth+1-FONTHEIGHT, 
			  (boardsz-1)*widt, FONTHEIGHT);
    graph->dString((windowwidth-strlen(CONFLICTSTRING)*FONTWIDTH)/2,
		   windowheight-windowwidth,CONFLICTSTRING);
    redraw = true;
  }

  if((gameStart && !counting) || 
     param == COM_SCROLLUP || param==COM_SCROLLDOWN){
    graph->emptyRectangle(0, 0, windowwidth-BUTTONSIZE, 
			  windowheight-windowwidth-FONTHEIGHT+1); 
    
    drawTopBoxes();

    drawChoices(cur, (lastcur==cur)?param:COM_BEGIN);
    lastcur = cur;
  }
}




void GoBoxes::setKomi(int num, bool dotfive){
  komiI=num;
  komiB=dotfive;
}

void GoBoxes::setHandi(int h){
  handicp = h;
}

void GoBoxes::setGameStart(){
  gameStart = true;
}

void GoBoxes::setCounting(){
  counting = true;
}

void GoBoxes::setConflict(bool cf){
  conflic = cf;
}

void GoBoxes::unsetCounting(){
  counting = false;
}

void GoBoxes::setBoardProp(int bs, int xs, int w){
  boardsz = bs;
  xstar = xs;
  widt = w;
  char moves[MAXSTRING+1];
  dig3i2str(last_mn,moves);
  start_left = 
    xstar+((boardsz-1)*widt - (numw+numb+strlen(moves)+7)*
	   FONTWIDTH)/2 +numb * FONTWIDTH;
  start_right = start_left + (4 + digits(last_mn))*FONTWIDTH;
}




void GoBoxes::setProperties(int w, bool as, bool sd, bool cord){
  x = y= 0;
  curchoices = 0;
  autosave = as;
  sound = sd;
  coordinates = cord;
  stonerad = w/2;
  if((windowheight-windowwidth-FONTHEIGHT)/(2*stonerad) < 4)
    stonerad = (windowheight-windowwidth-FONTHEIGHT)/20;

}

void GoBoxes::drawComment(Move* cur, int npo){
  static int begline = 0;
  if(cur == 0) return;
  if(cur->comment==0) return;

  int rowlength = (windowwidth - BUTTONSIZE)/FONTWIDTH;
  int lines = (windowheight-windowwidth - BUTTONSIZE - FONTHEIGHT)/FONTHEIGHT;
  char display[lines][rowlength+1];
  int i=0,j, pos=0;

  // do the scrolling part.
  switch(npo){
  case COM_BEGIN:
    begline = 0;
    break;
  case COM_SCROLLUP:
    begline += 1-lines;
    if(begline<0) begline = 0;
    break;
  case COM_SCROLLDOWN:
    begline += lines-1;
  }
  //  printf("%d\n",begpos);
  if(begline!=0){ 
    for (j=0; j<begline; j++){
      for(i=0; i<rowlength; i++,pos++){
	if(pos<strlen(cur->comment) && (cur->comment)[pos]!='\n') ;
	else break;
      }
      if(i==rowlength){
	for(; (cur->comment)[pos]!=' '&&i>0; i--,pos--) ;
	if(i==0) {pos+=rowlength; i=rowlength;}
      }
      if(pos>=strlen(cur->comment)) break;
      if((cur->comment)[pos]==' '|| (cur->comment)[pos]=='\n') pos++;
    }
  }
  //  printf("%d\n", pos);
  
  for (j=0; j<lines; j++){
    for(i=0; i<rowlength; i++,pos++){
      if(pos<strlen(cur->comment) && (cur->comment)[pos]!='\n') 
	display[j][i]=(cur->comment)[pos];
      else break;
    }
    if(i==rowlength){
      for(; (cur->comment)[pos]!=' '&&i>0; i--,pos--) ;
      if(i==0) {pos+=rowlength; i=rowlength;}
    }
    display[j][i]=0;
    graph->dString(0,BUTTONSIZE+(j+1)*FONTHEIGHT, display[j]);
    if(pos>=strlen(cur->comment)) break;
    if((cur->comment)[pos]==' '|| (cur->comment)[pos]=='\n') pos++;
  }
  scrollDown=scrollUp=false;
  if(begline > 0){
    scrollUp = true;
    graph->rectangle(0,0,BUTTONSIZE-1,BUTTONSIZE-1);
    graph->line(0,BUTTONSIZE/2, BUTTONSIZE-1, BUTTONSIZE/2);
    graph->line(2,BUTTONSIZE/2-2, BUTTONSIZE/2, 2);
    graph->line(BUTTONSIZE-3,BUTTONSIZE/2-2, BUTTONSIZE/2, 2);
  }
  if(pos<strlen(cur->comment)){
    scrollDown = true;
    graph->rectangle(0,0,BUTTONSIZE-1,BUTTONSIZE-1);
    graph->line(0,BUTTONSIZE/2, BUTTONSIZE-1, BUTTONSIZE/2);
    graph->line(2,BUTTONSIZE/2+2, BUTTONSIZE/2, BUTTONSIZE-3);
    graph->line(BUTTONSIZE-3,BUTTONSIZE/2+2, BUTTONSIZE/2, BUTTONSIZE-3);
  }
}

