// here, you can decide if you want to compile using the PC-default values or 
// the agenda default values. You can change the rest as well; 
// at the moment, only the window size depends on this part here.
//#define PC
//#define AGENDA
//#define ZAURUS
//#define EZX

//comment the next line if you do not wish REPLACE-will-advance
#define REPLACE_WILL_ADVANCE
// comment the next line if you want to start loaded games at the beginning
#define loadGameEnd

// set the default komi value here
// the integral part
#define KOMI_INTEGER 6
// do you wish the komi to be integral, 
// or do you want to add ".5" to the number above? 
#define KOMI_DOT_FIVE true

// set SOUNDDEFAULT to true or false, depending on whether you wish to have 
// sound enabled by default (true), or not (false).
#define SOUNDDEFAULT false
#define SOUNDDURATION 20
#define SOUNDVOLUME   100  // 0 to 100; doesn't seem to work anyway

//define auto-save if you want to save even if you might overwrite an 
//existing file
#define ALWAYSAUTOSAVE             false
#define ALWAYSAUTOSAVEWITHFILENAME false
#define AUTOSAVEWITHEMPTYFILE      true
// comment below if you do not want to create an extra safetycopy when in 
// autosave mode (see goVRec manual)
// the number specifies how often to make a safetycopy. 1 stands for always.
#define MAKESAFETYCOPY 3

// set COPYCOMMAND to a command which can be used in the form
// COPYCOMMAND filename filename~    on your system.
#define COPYCOMMAND "cp -f"

// set the below variable to REPLACEBUTTON if you want to be in replace-move
// by default. VARIATIONBUTTON is the default.
#define DEFAULTREPLACEVALUE VARIATIONBUTTON

// define the below as true to display comments by default, 
// even if there are variations around.
// For the opposite behaviour set to false.
#define DEFAULT_DISPLAY_COMMENT true

// if you don't define ALLOWTOGGLECOORD, 
// you don't get the box to toggle coordinates
#define ALLOWTOGGLECOORD
#define DEFAULT_COORDINATES true

#if defined AGENDA
   #define WINDOWWIDTH  160
   #define WINDOWHEIGHT 240
   #define AUTOSAVESTRING             "a"
   #define SOUNDSTRING                "s"
   #define COORDSTRING                "c"
// define SMALLFONT to be the name of the font you want to use for coordinates.
// undefine SMALLFONT to have the default font be used.
   #define SMALLFONT   "5x7"

// change the pitch of the sounds here
// you can disable individual of the tones by setting them to very low values
   #define STONEPITCH     40
   #define SYSTEMPITCH    45
   #define ALARMPITCH     200
// here, you can define the color for the agenda; play around with it!
   #define REDCOLORVALUE 255
   #define GREENCOLORVALUE 150
   #define BLUECOLORVALUE 75
#endif

#if defined ZAURUS
   #define WINDOWWIDTH  240
   #define WINDOWHEIGHT 320
   #define AUTOSAVESTRING             "a.s."
   #define SOUNDSTRING                "sound"
   #define COORDSTRING                "c"
// define SMALLFONT to be the name of the font you want to use for coordinates.
// undefine SMALLFONT to have the default font be used.
   #define SMALLFONT   "5x7"
// change the pitch of the sound here
// you can disable individual of the tones by setting them to very low values
   #define STONEPITCH     150
   #define SYSTEMPITCH    200
   #define ALARMPITCH     250
//define your favorite color here; you can look it up using "showrgb".
   #define REDCOLORVALUE 225
   #define GREENCOLORVALUE 150
   #define BLUECOLORVALUE 60
#endif

#if defined EZX
   #define WINDOWWIDTH  238
   #define WINDOWHEIGHT 296
   #define AUTOSAVESTRING             "a.s."
   #define SOUNDSTRING                "sound"
   #define COORDSTRING                "c"
// define SMALLFONT to be the name of the font you want to use for coordinates.
// undefine SMALLFONT to have the default font be used.
//   #define SMALLFONT   "5x7"
/* up to now, sound is only beep, and even that doesn't work
// change the pitch of the sound here
// you can disable individual of the tones by setting them to very low values
   #define STONEPITCH     150
   #define SYSTEMPITCH    200
   #define ALARMPITCH     250
*/
//define your favorite color here; play around with it!
   #define REDCOLORVALUE 225
   #define GREENCOLORVALUE 150
   #define BLUECOLORVALUE 60
// #define USE_QT is done by the Makefile
#endif

#if defined PC
   #define WINDOWWIDTH  400
   #define WINDOWHEIGHT 500
   #define AUTOSAVESTRING             "autosave"
   #define SOUNDSTRING                "sound"
   #define COORDSTRING                "coordinates"
// define SMALLFONT to be the name of the font you want to use for coordinates.
// undefine SMALLFONT to have the default font be used.
//   #define SMALLFONT   "6x13"

// change the pitch of the sound here
// you can disable individual of the tones by setting them to very low values
   #define STONEPITCH     150
   #define SYSTEMPITCH    200
   #define ALARMPITCH     250
//define your favorite color here; you can look it up using "showrgb".
   #define REDCOLORVALUE 225
   #define GREENCOLORVALUE 150
   #define BLUECOLORVALUE 60
#endif 

#define MOVEBUTTON      2
#define VARIATIONBUTTON 3
#define REPLACEBUTTON   4
#define ADDBUTTON       5
#define EMPTYBUTTON     6

//#define WINDOWWIDTH  240
//#define WINDOWHEIGHT 320

// at the moment, DEFAULTBOARDSIZE applies only to sgf files without 
// given size. The default size at startup for a new game is hardcoded.
#define DEFAULTBOARDSIZE  19

#define CONFLICTSTRING "CONFLICT! REPLACE!"

// here you can mix & match the markation symbols as you please
// by adapting the last part
#define REDRAWMARK       -1
#define REMOVEMARK       -2
#define PASSMARKW        -3
#define PASSMARKB        -4

#define NORMALMARK       -5
#define REPLACEMARK      -6
#define CONFLICTMARK     -7
#define ADDMARK          -8

#define PLUS             -5
#define DOT              -6
#define TIMES            -7
#define FOURDOTS         -8

// the default filenames
#define FILENAME     "gogames/govrec.sgf"
#define ALTERNATEFILE "govrec.sgf"
// if you started govrec from a directory you don't have write permission for
#define THIRDFILE  "/home/default/govrec.sgf"



#define PLAYERBLACK "Black"
#define PLAYERWHITE "White"

//don't change these - they have no influence on the actual size of the font
//#define DEFAULTFONT "6x13"
#define FONTWIDTH    6
#define FONTHEIGHT   12

// don't change the rest (unless you know what you are doing)
#define BUTTONSIZE 15

#define FILESTART    "(;GM[1]FF[3]RU[Chinese]\nSZ["

#define FILEMED   "SY[goVRec 0.99c]\n"

#define FILEEND   ")\n"

#define WHITE        true
#define BLACK        false



// for isInButton in isInButton
#define NOTHING      -1
#define TOGGLEAUTOSAVE -2
#define TOGGLESOUND    -3
#define DECR_SIZE     -4
#define INCR_SIZE     -5
#define DECR_HANDI    -6
#define ROT_HANDI     -7
#define INCR_HANDI    -8
#define DECR_KOMI     -9
#define INCR_KOMI     -10
#define TOGAMESTART   -11
#define DECR_MOVE     -12
#define INCR_MOVE     -13
#define TOGAMEEND     -14
#define QUIT          -15
#define MVR           -16
#define PASSB         -17
#define SCROLLDOWN    -18
#define SCROLLUP      -19
#define TOGGLEDISPLAY -20
#define TOGGLECOORD   -21

#define U            2
#define D            4
#define L            8
#define R           16
#define KO          32
#define PASS        64
#define MULT       128
#define OK           1
#define NO           0

//for the position of comments
#define COM_BEGIN   0
#define COM_REDRAW  1
#define COM_SCROLLUP 2
#define COM_SCROLLDOWN 3

// to distinguish the sounds
#define STONETONE    1
#define SYSTEMTONE   2
#define ALARMTONE    3

#define MAXSTRING   80

